﻿#ifndef JSONARRAY_H
#define JSONARRAY_H

#include <QObject>
#include<QVariant>
class  JSONArray : public QObject
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit JSONArray(QObject *parent = nullptr);
    Q_INVOKABLE ~JSONArray();
    Q_INVOKABLE JSONArray(const JSONArray &jsonArr);
    Q_INVOKABLE QString toJSONString();
    Q_INVOKABLE void add(QVariant elem);
    Q_INVOKABLE void add(QObject* elem);
    Q_INVOKABLE void add(int index, QVariant elem);
    Q_INVOKABLE void addAll(QVariant collection);
    Q_INVOKABLE void addAll(int index, QVariant collection);
    Q_INVOKABLE void clear();
    Q_INVOKABLE bool contains(QVariant elem);
    Q_INVOKABLE bool containsAll(QVariant collection);
    Q_INVOKABLE QVariant get(int index);
    Q_INVOKABLE int indexOf(QVariant elem);
    Q_INVOKABLE bool isEmpty();
    Q_INVOKABLE QVariant remove(int index);
    Q_INVOKABLE bool remove(QVariant elem);
    Q_INVOKABLE bool removeAll(QVariant collection);
    Q_INVOKABLE void set(int index, QVariant elem);
    Q_INVOKABLE QVariantList toArray();
    Q_INVOKABLE int size() const;

public:
    QVector<QVariant> m_jsonVec;

private:
    QJsonValue getSubItem(QVariant item);
};
Q_DECLARE_METATYPE(JSONArray)
#endif // JSONARRAY_H
