﻿#ifndef JSONOBJ_H
#define JSONOBJ_H

#include <QObject>
#include <QJSValue>
#include <QMapIterator>
#include<QVariant>
class  JSONObj : public QObject
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit JSONObj(QObject* parent = nullptr);
    Q_INVOKABLE JSONObj(const JSONObj &jsonObj);
//    Q_INVOKABLE JSONObj(QJSValue map);
//    Q_INVOKABLE JSONObj(Vector *vector);
    Q_INVOKABLE ~JSONObj();
    Q_INVOKABLE QString toJSONString();
    Q_INVOKABLE QVariant getJSONObject(QString key);
    Q_INVOKABLE QVariant getJSONArray(QString key);
    Q_INVOKABLE int size();
    Q_INVOKABLE bool isEmpty();
    Q_INVOKABLE void put(QString key, QVariant value);
    Q_INVOKABLE QVariant get(QString elem);
    Q_INVOKABLE void remove(QString key);
    Q_INVOKABLE void clear();
    Q_INVOKABLE QVariantList keySet();
    Q_INVOKABLE QVariantList values();
    Q_INVOKABLE JSONObj *entrySet();
    Q_INVOKABLE JSONObj *iterator();

    Q_INVOKABLE QString getString(QString elem);
    Q_INVOKABLE QString toString();
    Q_INVOKABLE QVariant getData();

    Q_INVOKABLE double getDouble(QString elem);

    JSONObj &operator =(const JSONObj & obj);

    Q_INVOKABLE bool hasNext();
    Q_INVOKABLE JSONObj* next();
    Q_INVOKABLE QString getKey();
    Q_INVOKABLE QVariant getValue();

public:
    QMap<QString, QVariant> m_jsonMap;

private:
    QJsonValue getSubItem(QVariant item);

private:
    QMapIterator<QString, QVariant> *m_iterator;
};
Q_DECLARE_METATYPE(JSONObj)
#endif // JSONOBJ_H
