#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>
#include "jsonobj.h"
#include "jsonarray.h"
int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QGuiApplication app(argc, argv);


    QQmlApplicationEngine engine;

    QJSValue jsonObj = engine.newQMetaObject(&JSONObj::staticMetaObject);
    engine.globalObject().setProperty("JSONObj", jsonObj);

    QJSValue jsonary = engine.newQMetaObject(&JSONArray::staticMetaObject);
    engine.globalObject().setProperty("JSONArray", jsonary);


    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
